<?php
// $Id: cron_control_admin.inc,v 1.2 2009/10/08 15:01:01 mkalkbrenner Exp $

function cron_control_get_jobs($order = 'module') {
  $order_detail = array('module' => 'module, server_addr', 'server_addr' => 'server_addr, module');
  $jobs = array();
  if ($result = db_query("SELECT module, server_addr, active FROM {cron_control_jobs} ORDER BY %s", $order_detail[$order])) {
    while ($job = db_fetch_object($result)) {
      $jobs[$job->$order][] = $job;
    }
  }
  return $jobs;
}

function cron_control_jobs_by_module_form($form_state) {
  $form = array();

  $jobs = cron_control_get_jobs('module');

  foreach (array_keys($jobs) as $module) {
    $form['cron_control_jobs_' . $module] = array(
      '#type' => 'fieldset',
      '#title' => $module,
      '#collapsible' => true,
      '#collapsed' => true,
      '#description' => t('Configure hosts to execute cron job of !module module.', array('!module' => $module)),
    );

    foreach ($jobs[$module] as $job) {
      $form['cron_control_jobs_' . $module]['cron_control_' . $job->module . '/' . str_replace('.', '_', $job->server_addr)] = array(
        '#type' => 'checkbox',
        '#title' => $job->server_addr,
        '#default_value' => $job->active,
        '#description' => t('Enable cron job of !module module on host !server_addr.', array('!module' => $job->module, '!server_addr' => $job->server_addr)),
      );
    }
  }

  $form['cron_control_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  $form['#submit'] = array('cron_control_jobs_form_submit');

  return $form;
}


function cron_control_jobs_by_server_addr_form($form_state) {
  $form = array();

  $jobs = cron_control_get_jobs('server_addr');

  foreach (array_keys($jobs) as $server_addr) {
    $form['cron_control_jobs_' . $server_addr] = array(
      '#type' => 'fieldset',
      '#title' => $server_addr,
      '#collapsible' => true,
      '#collapsed' => true,
      '#description' => t('Enable cron jobs on host !server_addr.', array('!server_addr' => $server_addr)),
    );

    foreach ($jobs[$server_addr] as $job) {
      $form['cron_control_jobs_' . $server_addr]['cron_control_' . $job->module . '/' . str_replace('.', '_', $job->server_addr)] = array(
        '#type' => 'checkbox',
        '#title' => $job->module,
        '#default_value' => $job->active,
        '#description' => t('Enable cron job of !module module on host !server_addr.', array('!module' => $job->module, '!server_addr' => $job->server_addr)),
      );
    }
  }

  $form['cron_control_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  $form['#submit'] = array('cron_control_jobs_form_submit');

  return $form;
}


function cron_control_jobs_form_submit($form, &$form_state) {
  foreach ($form_state['values'] as $key => $value) {
    if (strpos($key, 'cron_control_jobs_') === 0) {
      list($module, $server_addr) = explode('/', str_replace('cron_control_', '', $key));
      $job = array(
        'module' => $module,
        'server_addr' => str_replace('_', '.', $server_addr),
        'active' => $value,
      );
      drupal_write_record('cron_control_jobs', $job, array('module', 'server_addr'));
    }
  }
}
